#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <stdlib.h>
#include <stdint.h>
#include "global.h"
#include <util/crc16.h>
#include "rf02.c"
#include <util/delay.h>
#include <string.h> 
#include <avr/sleep.h>


//#define F_CPU 8000000UL


//unsigned char test[32]="0000001111100000888888888\n";

#define ALIVE 1 
#define GEAR 2
#define ALARM 3

volatile unsigned char internalINT=0; //        
#define stop1 ((PINA & (1<<1))?1:0) //   PINA1 (STOP )
#define blink1 ((PINA & (1<<0))?1:0) //   PINA0 ( )

/*
void changeText( unsigned char * ptr, uint8_t len){

 memcpy( test, ptr, len);
}
*/

/*
void prepAll(void){

	rf02_init();					// ein paar Register setzen (z.B. CLK auf 10MHz)
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
	rf02_setfreq(RF02FREQ(434));	// Sende/Empfangsfrequenz auf 433,92MHz einstellen
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
	rf02_setpower(1);				// -12dBm Ausgangangsleistung
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
	rf02_setmodfreq(3);				// 120kHz Frequenzshift
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
	rf02_setbaud(19200);			// 19200 Baud
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
PORTD ^= 0b00010000;
_delay_ms(100);
_delay_ms(100);
//	unsigned char newTtest[11]="hello all\n";
//	changeText(newTtest, 11);
}
*/

//   +2
void lo (void)
{
 rf02_trans(0x8BE0);
}
//   -2
void hi (void)
{
 rf02_trans(0x8BF0);
}

/******************   WATCHDOG ********************/
SIGNAL(WDT_OVERFLOW_vect){
 //internalINT=2;
}

void go_sleep(void){
 //    POWER-DOWN
 cli(); //   
 set_sleep_mode(SLEEP_MODE_PWR_DOWN);
 sei(); //   
 sleep_mode();
 _delay_ms(20);

PORTD ^= 0b00010000;
_delay_ms(800);
_delay_ms(800);
PORTD ^= 0b00010000;

}


/******************    INT0    (   POWER-DOWN) ********************/
SIGNAL(INT0_vect){
//       INT0,    INT0
GIMSK=0;  // External Interrupt Request 0 Disable
EIFR=0; // External Interrupt Flag 0 Disable
internalINT=1;

PORTD ^= 0b00010000;
_delay_ms(800);
PORTD ^= 0b00010000;

}

int main(void)
{
//  ()
DDRB=0b11101111; //     PINB,  PB4(IRQ).
PINB=0b00000000; //     PORTB 0
PORTB=0b00000000; //     +.

DDRD=0b11111011; //     PIND,  PD2 (INT0)
PIND=0b00000000; //     PORTD 0
PORTD=0b00000000; //     +.

DDRA=0b11111100; //     PINA,  PA1 (STOP)  PA0 (STOP).
PINA=0b00000000; //     PORTD 0
PORTA=0b00000000; //     +.

//  wachdog
WDTCSR|=(1<<WDIF)|(1<<WDIE)|(0<<WDE)|(1<<WDIE); // Watchdog Interrupt Flag=Enable, Watchdog Interrupt Enable, Mode=Interrupt Mode
WDTCSR|=(1<<WDP3)|(0<<WDP2)|(0<<WDP1)|(1<<WDP0); // Watchdog Typical Time=8sec (    8 )


sbi(RF_PORT, CS); // nSEL  
cbi(RF_PORT, SDI); // SDI  
cbi(RF_PORT, SCK); // SCK  

//  
PORTD ^= 0b00110000;
_delay_ms(800);
PORTD ^= 0b00110000;
_delay_ms(800);

PORTD ^= 0b00010000;
// init rfm02, see datasheet
rf02_trans(0b1100110000000000); // read status

// Configuration Setting Command: band[MHz]=433,CLK frequency[MHz]=2,Load capacitor [pF]=10,ms=0,frequency deviation[kHz]=60
rf02_trans(0b1000101110000001); 

// Power Management Command: close all ,the module will get into the sleep state.
//rf02_trans(0b1100000000000001);

// Frequency Setting Command: 433band: Fc=430+1600*0.0025= MHz
rf02_trans(0b1010011001000000);

// Data Rate Command: data rate=4.8k bps 
rf02_trans(0b1100100001000111);

// Low Battery Detector and Tx bit Synchronization Command: 
// dwc: Disable wake-up timer periodical calibration
// ebs: Enable TX bit synchronization function
// Disable Low battery detector
rf02_trans(0b1100001000100000);

// PLL Setting and Reset Mode Command: 
// PLL bandwidth: Max datarate [kbps]=19.2, Phase Noise at 1MHz offset [dBc/Hz](typical)=-112,Charage pump current=25%
rf02_trans(0b1101001001000000);

// Power Management Command:
// ea:Enable power amplifier
// ex:Enable crystal oscillator
// es:Enable synthesizer
rf02_trans(0b1100000000111000);

// Power Setting Command: set relative output power:=MAX
rf02_trans(0b10110000);
PORTD ^= 0b00010000;
_delay_ms(800);

data.id_transmitter=1;
//   eeprom    
if (eeprom_read_dword((uint32_t*)15)!=0xFF){
 data.incr=eeprom_read_dword((uint32_t*)15);
} else {data.incr=0;}

MCUCR|=(0<<ISC01)|(0<<ISC00); // The low level of INT0 generates an interrupt request.
GIMSK|=(1<<INT0);  // External Interrupt Request 0 Enable
EIFR|=(1<<INTF0); // External Interrupt Flag 0


sei(); //   
//go_sleep(); // 

//	prepAll();
	for (;;)
	{

	if ((stop1==1) || (blink1==1)){
	 //  STOP   
     if ((stop1==1)){
	  //   , ..    
      data.command=GEAR;
	 }
     if ((blink1==1)){
      //  , ..  
      data.command=ALARM;
	 }
	} else {
     data.command=ALIVE;
     //        WatchDog,    INT0
     MCUCR|=(0<<ISC01)|(0<<ISC00); // The low level of INT0 generates an interrupt request.
     GIMSK|=(1<<INT0);  // External Interrupt Request 0 Enable
     EIFR|=(1<<INTF0); // External Interrupt Flag 0
	}

eeprom_write_word((void*)15,data.incr); //   15  eeprom   
//rf02_txdata((uint8_t*)&data+sizeof(data_struct)-1);

		_delay_ms(800);
        PORTD ^= 0b00100000;
        rf02_trans(0b1000101111100000); // TX on (Configuration Setting Command)
		_delay_ms(800);
		//rf02_txdata(test,32);
		rf02_txdata((uint8_t*)&data+sizeof(data_struct)-1); //     
        data.incr++;
		_delay_ms(800);
        rf02_trans(0b1000101110000001); // TX off (Configuration Setting Command)
        PORTD ^= 0b00100000;
		_delay_ms(800);
		_delay_ms(800);
        go_sleep(); // 
	}
}

//http://www.mikrocontroller.net/topic/67273#new
//http://www.hoperf.cn/pdf/HM-TR_EN.pdf
//http://www.integration.com/resources.shtml
//http://www.integration.com/docs/IA_MSC-UGSB1.pdf
//http://www.integration.com/docs/IA_ISM-AN1.pdf
//http://www.dj4uf.de/projekt/ant/ant.htm#Grounplane-Antenne
//http://home.worldonline.nl/~moertje/jota/hb9-70cm.jpg

//http://img158.imageshack.us/img158/5593/rfm12bondingxe3.jpg
//http://www.integration.com/products/wireless_selector.shtml
//http://de.wikipedia.org/wiki/Usart

//http://www.mikrocontroller.net/articles/AVR_RFM12

//http://www.mikrocontroller.net/topic/67273#new






